using System;
using System.Drawing;
using System.Text.RegularExpressions;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Styles;

namespace I51257
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
    {
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
        private DataCollection dataSource;

		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
            ((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
            this.SuspendLayout();
            // 
            // gridDataBoundGrid1
            // 
            this.gridDataBoundGrid1.AllowDragSelectedCols = true;
            this.gridDataBoundGrid1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridDataBoundGrid1.Location = new System.Drawing.Point(0, 0);
            this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
            this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
            this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
            this.gridDataBoundGrid1.Size = new System.Drawing.Size(361, 300);
            this.gridDataBoundGrid1.SmartSizeBox = false;
            this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
            this.gridDataBoundGrid1.TabIndex = 1;
            this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
            this.gridDataBoundGrid1.UseListChangedEvent = true;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(361, 300);
            this.Controls.Add(this.gridDataBoundGrid1);
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "GDBG showing derived FilterBar";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void Form1_Load(object sender, EventArgs e)
        {
            Random rand = new Random();
            int r = rand.Next(100);

            dataSource = new DataCollection();

            for (int i = 0; i < 20; i++)
            {
                if (i < 10)
                {
                    dataSource.Add(new Data(r.ToString(), "Category" + r.ToString(), "Desc" + r.ToString()));
                    r = rand.Next(100);
                }
                else
                {
                    dataSource.Add(new Data(r.ToString(), "A"+r.ToString (), "Desc" + r.ToString()));
                    r = rand.Next(100);
                }
            }
            this.gridDataBoundGrid1.DataSource = dataSource;

            MyGridFilterBar _filterBar = new MyGridFilterBar();
            _filterBar.WireGrid(gridDataBoundGrid1,dataSource  );
        }
    }

	#region Derived FilterBar

    public class MyGridFilterBar : GridFilterBar
    {
        DataCollection originalSource = null;
        DataCollection filteredSource = null;

        string rowFilter = "";

        public MyGridFilterBar()
            : base()
        {
        }

        #region Properties

        public DataCollection OriginalSource
        {
            get { return originalSource; }
            set { originalSource = value; }
        }

        public new string RowFilter
        {
            get { return rowFilter; }
            set 
            {
                GridDataBoundGrid grid = GetGrid();
                if (grid.DataSource is DataCollection)
                {
                    rowFilter = GetFilterFromRow(grid);
                    ApplyFilter(grid, rowFilter);
                }
                else
                {
                    base.RowFilter = value;
                }
            }
        }
        #endregion

        #region ApplyFilter method

        protected virtual void ApplyFilter(GridDataBoundGrid grid, string filter)
        {
            grid.Binder.SuspendBinding();
            grid.BeginUpdate();

            Console.WriteLine(filter);
            string[] conditions = filter.Split(new char[] { ',' });

            bool valid = false;
            string column = "";
            string value = "";
            int start, end;
            if (conditions != null)
            {
                foreach (Data item in OriginalSource)
                {
                    foreach (string condition in conditions)
                    {
                        start = condition.IndexOf('[');
                        end = condition.IndexOf(']');
                        column = condition.Substring(start + 1, end - start-1);
                        start = condition.IndexOf('=');
                        end = condition.LastIndexOf(')');
                        value = condition.Substring(condition.IndexOf('=') + 1, end - start-1).Trim();
                        if (value == "")
                        {
                            valid = true;
                        }
                        else
                        {
                            if (column == "CategoryName" && item.CategoryName ==value )//&& item.CategoryName.StartsWith("A"))
                                valid = true;
                            else if (column == "CategoryID" && item.CategoryID == value)
                                valid = true;
                            else if (column == "Description" && item.Description == value)
                                valid = true;
                            else
                                valid = false;
                        }
                    }
                    if (valid)
                    {
                        if (!filteredSource.Contains(item))
                        {
                            filteredSource.Add(item);
                        }
                    }
                    else
                    {
                        if (filteredSource.Contains(item))
                        {
                            filteredSource.Remove(item);
                        }
                    }
                }
            }

            if (grid.DataSource != filteredSource)
            {
                grid.DataSource = filteredSource;
            }
            grid.Binder.ResumeBinding();
            grid.EndUpdate(true);
            grid.Refresh();
        }

        #endregion

        #region GetFilterFromRow method

        protected override string GetFilterFromRow(GridDataBoundGrid grid)
        {
            if (grid.DataSource is DataCollection)
            {
                GridCurrentCell cc = grid.CurrentCell;
                int col = cc.ColIndex;
                int row = this.GetFilterRow();
                DataTable dt = this.GetDataTable();
                string s = cc.Renderer.ControlText;
                string rowFilter = "";
                
                string colName = grid.Binder.InternalColumns[grid.Binder.ColIndexToField(col)].MappingName;
                grid[row, col].Text = s;
                grid[row, col].Tag = string.Format("[{0}] = {1}", colName, s);

                //Form the filter string from the filter row values.
                for (int j = 1; j <= grid.Model.ColCount; ++j)
                {
                    s = grid[row, j].Tag as string;
                    if (s != null && s.Length > 0)
                    {
                        if (rowFilter.Length > 0)
                            rowFilter += ",";
                        rowFilter += string.Format("({0})", s);
                    }
                }
                return rowFilter;
            }
            else
            {
                return base.GetFilterFromRow(grid);
            }
        }

        #endregion

        #region WireGrid method

        public virtual void WireGrid(GridDataBoundGrid grid, DataCollection collection)
        {
            if (collection != null)
            {
                OriginalSource = collection;

                if (filteredSource == null)
                    filteredSource = new DataCollection();

                filteredSource.Clear();
                foreach (Data item in collection)
                {
                    filteredSource.Add(item);
                }
                grid.DataSource = filteredSource;
                grid.Refresh();
                this.WireGrid(grid);
            

            }
        }

        public override void WireGrid(GridDataBoundGrid grid, GridStyleInfo style)
        {
            DataCollection collection = null;
            if (grid.DataSource is IList)
            {
                if (originalSource != null)
                {
                    collection = originalSource;
                    this.StyleInfo = style;
                    style.DropDownStyle = GridDropDownStyle.Editable;

                    //Add a fixed row at the top.
                    grid.Model.Data.RowCount++;
                    SetFilterRow(grid.Model.Rows.HeaderCount + 1);
                    int row = GetFilterRow();
                    grid.Model.Rows.HeaderCount = row;
                    grid.Model.Rows.FrozenCount = grid.Model.Rows.FrozenCount + 1;

                    grid.Model.ChangeCells(GridRangeInfo.Cells(row, 1, row, grid.Model.ColCount), style, StyleModifyType.Override);

                    GridBoundColumnsCollection gbcc;
                    gbcc = (grid.GridBoundColumns.Count == 0) ? grid.Binder.InternalColumns : grid.GridBoundColumns;

                    for (int gbcIndex = 0; gbcIndex < gbcc.Count; ++gbcIndex)
                    {
                        string colName = gbcc[gbcIndex].MappingName;
                        int col = grid.Binder.NameToColIndex(colName);

                        GridFilterBarCreatingColumnHeaderEventArgs e = new GridFilterBarCreatingColumnHeaderEventArgs(colName);
                        OnCreatingColumnHeader(e);
                        if (e.Cancel)
                        {
                            grid[row, col].ShowButtons = GridShowButtons.Hide;
                            continue;
                        }
                        //Allow event handler to change the colname used to define the choices.
                        colName = e.ColName;

                        grid[row, col].DataSource = CreateUniqueEntries(collection, colName);
                        grid[row, col].DisplayMember = colName;
                        grid[row, col].ValueMember = colName;
                    }

                    //Hook up handers.
                    grid.CurrentCellAcceptedChanges += new CancelEventHandler(grid_CurrentCellAcceptedChanges);
                    grid.CurrentCellShowingDropDown += new GridCurrentCellShowingDropDownEventHandler(this.GridCurrentCellShowingDropDown);
                    grid.CurrentCellCloseDropDown += new PopupClosedEventHandler(grid_CurrentCellCloseDropDown);
                    grid.CurrentCellChanged += new EventHandler(grid_CurrentCellChanged);
                    grid.KeyDown += new KeyEventHandler(this.GridKeyDown);
                    SetGrid(grid);
                }
            }
            else
            {
                base.WireGrid(grid, style);
            }
        }

        void grid_CurrentCellChanged(object sender, EventArgs e)
        {
            GridDataBoundGrid grid = sender as GridDataBoundGrid;
            if (grid != null)
            {
                GridCurrentCell cc = grid.CurrentCell;
                if (cc.RowIndex == this.GetFilterRow())
                {
                    cc.Lock();
                    for (int i = 1; i <= grid.Model.ColCount; i++)
                    {
                        if (i != cc.ColIndex)
                        {
                            grid[cc.RowIndex, i].Tag = null;
                            grid[cc.RowIndex, i].CellValue = "";
                        }
                    }
                    this.RowFilter = GetFilterFromRow(grid);
                    cc.Unlock();
                }
            }
        }

        #endregion

        #region Event handlers

        void grid_CurrentCellCloseDropDown(object sender, PopupClosedEventArgs e)
        {
            this.GridCurrentCellCloseDropDown(sender, e);
			GridComboBoxCellRenderer renderer = GetGrid().CurrentCell.Renderer as GridComboBoxCellRenderer;
			if(renderer!=null)
			{
				if(renderer.ListBoxPart.SelectedIndex==0)
				{
					GetGrid().CurrentCell.IsModified = true;
					GetGrid().CurrentCell.ConfirmChanges();
				}
			}
        }

        void grid_CurrentCellAcceptedChanges(object sender, CancelEventArgs e)
        {
            GridDataBoundGrid grid = sender as GridDataBoundGrid;
            if (grid != null)
            {
                GridCurrentCell cc = grid.CurrentCell;
                if (cc.RowIndex == this.GetFilterRow())
                {
                    cc.Lock();
                    for (int i = 1; i <= grid.Model.ColCount; i++)
                    {
                        if (i != cc.ColIndex)
                        {
                            grid[cc.RowIndex, i].Tag = null;
                            grid[cc.RowIndex, i].CellValue = "";
                        }
                    }
                    this.RowFilter = GetFilterFromRow(grid);
                    cc.Unlock();
                }
            }
        }

        #endregion

        #region CreateUniqueEntries method

        protected virtual DataTable CreateUniqueEntries(DataCollection collection, string colName)
        {
            DataTable dt = new DataTable(colName);
            dt.Columns.Add(new DataColumn(colName));

            dt.PrimaryKey = new DataColumn[] { dt.Columns[colName] };

            //To add the 'none' option
            DataRow dr;
                dr = dt.NewRow();
                dr[0] = "";
                dt.Rows.Add(dr);

            string value = "";

            for (int i = 0; i < collection.Count; ++i)
            {
                if (colName == "CategoryName")
                    value = collection[i].CategoryName.ToString();
                else if (colName == "CategoryID")
                    value = collection[i].CategoryID.ToString();
                else if (colName == "Description")
                    value = collection[i].Description.ToString();
                else
                    value = "";

                if (!dt.Rows.Contains(value))
                {
                    dr = dt.NewRow();
                    dr[0] = value;
                    dt.Rows.Add(dr);
                }
            }
            return dt;
        }

        #endregion
    }
	#endregion   
}
